=== Library/reals/Makefile ===
# =====================================================================
#
#                MAKEFILE FOR THE HOL LIBRARY: reals
#
# =====================================================================

# =====================================================================
# MAIN ENTRIES:
#
#    make all       : create theories and compile code[*]
#
#    make clean     : remove only compiled code[*]
#
#    make clobber   : remove both theories and compiled code[*]
#
# [*] In fact this library contains no compiled code
# ---------------------------------------------------------------------
#
# MACROS:
#
#    Hol            : the pathname of the version of hol used
# =====================================================================

all:; cd theories; make all

clean:; cd theories; make clean

clobber:; cd theories; make clobber
