=== debian/changelog ===
hol88 (2.02.19940316dfsg-8) unstable; urgency=medium

  * build-dep latest gcl, select CLtL1 image

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 09:59:29 -0400

hol88 (2.02.19940316dfsg-7) unstable; urgency=medium

  * packaging cleanups
  * Bug fix: "ftbfs with GCC-15", thanks to Matthias Klose (Closes:
    #1096815).

 -- Camm Maguire <camm@debian.org>  Wed, 14 May 2025 08:08:20 -0400

hol88 (2.02.19940316dfsg-6) unstable; urgency=high

  * build-dep gcl27

 -- Camm Maguire <camm@debian.org>  Fri, 25 Apr 2025 13:46:25 -0400

hol88 (2.02.19940316dfsg-5) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 08 Jan 2023 17:11:46 -0500

hol88 (2.02.19940316dfsg-4) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 25 Dec 2022 17:55:57 -0500

hol88 (2.02.19940316dfsg-3) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 14:46:36 -0500

hol88 (2.02.19940316dfsg-2) unstable; urgency=medium

  * build-dep latest gcl
  * prune build-deps

 -- Camm Maguire <camm@debian.org>  Wed, 21 Dec 2022 12:57:57 -0500

hol88 (2.02.19940316dfsg-1) unstable; urgency=medium

  * Repack without NOWEB
  * Bug fix: "license issues", thanks to Bastian Germann (Closes:
    #1021314).
  * Accept NMU

 -- Camm Maguire <camm@debian.org>  Tue, 01 Nov 2022 21:20:09 -0400

hol88 (2.02.19940316-35.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Tue, 05 Jan 2021 12:37:31 +0100

hol88 (2.02.19940316-35) unstable; urgency=medium

  * build-dep latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 29 Aug 2017 22:52:36 +0000

hol88 (2.02.19940316-34) unstable; urgency=high

  * build-dep latest gcl
  * Bug fix: "FTBFS: Error: ERROR &quot;The default dispatch macro
    signalled an error.&quot;", thanks to Lucas Nussbaum (Closes:
    #871364).

 -- Camm Maguire <camm@debian.org>  Thu, 24 Aug 2017 10:59:05 +0000

hol88 (2.02.19940316-33) unstable; urgency=high

  * Bug fix: "hol88-library is an empty package on arm64, hppa, and m68k",
    thanks to Helmut Grohne (Closes: #857296).
  * build-dep on latest gcl
  * deprecated dh -s to -a in debian/rules
  * lintian override for hol88-help *.doc
  * temp files in clean target

 -- Camm Maguire <camm@debian.org>  Thu, 11 May 2017 19:24:09 +0000

hol88 (2.02.19940316-32) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 13 Oct 2016 19:34:07 +0000

hol88 (2.02.19940316-31) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 07 Oct 2015 21:39:55 +0000

hol88 (2.02.19940316-30) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 01 Oct 2015 22:16:36 +0000

hol88 (2.02.19940316-29) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 30 Sep 2015 22:03:50 +0000

hol88 (2.02.19940316-28) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 24 Oct 2014 10:35:41 -0400

hol88 (2.02.19940316-27) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Sun, 07 Sep 2014 22:37:23 -0400

hol88 (2.02.19940316-26) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 21 Aug 2014 18:47:39 +0000

hol88 (2.02.19940316-25) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 19 Aug 2014 19:21:14 +0000

hol88 (2.02.19940316-24) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 11 Aug 2014 16:13:22 +0000

hol88 (2.02.19940316-23) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Thu, 24 Jul 2014 21:47:33 +0000

hol88 (2.02.19940316-22) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Mon, 21 Jul 2014 14:58:54 +0000

hol88 (2.02.19940316-21) unstable; urgency=medium

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 16 Jul 2014 21:12:45 +0000

hol88 (2.02.19940316-20) unstable; urgency=low

  * build against latest gcl

 -- Camm Maguire <camm@debian.org>  Wed, 02 Jul 2014 20:34:24 +0000
